#!/usr/bin/perl -w
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#	author: haui; contact haui45@web.de

use strict;
my @array;
my %info;
my $in = "";
my $string = "";
my $pipe = " | dzen2 -bg black -fg white -e \"entertitle=grabmouse;button1=exit\"  -p 2 -w 1100 -h 18 -x 90";
	
	`which dzen2` or die "fatal...dzen2 not found\n";	#check our executables
	`which mocp` or die "fatal...mocp not found\n";		#uncomment if you're sure of having
								#both installed

	if (moc() == -1){
		$string = "echo \"mocp isn't playing\"" . $pipe;
		system($string);
		exit 0;

	}
		$string =~ s#`#\\0047#g;					# Making the string save for echo...
		$string =~ s#'#\\0047#g;					# 
		my $printstring = "echo -e '" . $string . "'" . $pipe;		#	
		system($printstring);						#
		exit 0;

sub moc {
	@array = `mocp -i`;
	foreach (@array) {
		if ($_ =~ m/^State:/) {$info{"state"} = $_; $info{"state"} =~ s/State: //; chomp $info{"state"}; next;}; 
		if ($_ =~ m/^SongTitle:/) {$info{"title"} = $_; $info{"title"} =~ s/SongTitle: //; chomp $info{"title"}; next;}; 
		if ($_ =~ m/^Artist/) {$info{"artist"} = $_; $info{"artist"} =~ s/Artist: //; chomp $info{"artist"}; next;}; 
		if ($_ =~ m/^Album/) {$info{"album"} = $_; $info{"album"} =~ s/Album: //; chomp $info{"album"}; next;} 
		if ($_ =~ m/^TotalTime/) {$info{"total"} = $_; $info{"total"} =~ s/TotalTime: //; chomp $info{"total"}; next;}; 
		if ($_ =~ m/^CurrentTime/) {$info{"current"} = $_; $info{"current"} =~ s/CurrentTime:[ ]*//; chomp $info{"current"}; next;}; 
		if ($_ =~ m/^Bitrate:/) {$info{"bitrate"} = $_; $info{"bitrate"} =~ s/Bitrate: //; chomp $info{"bitrate"}; next;}; 
		if ($_ =~ m/^Rate:/) {$info{"rate"} = $_; $info{"rate"} =~ s/Rate: //; chomp $info{"rate"}; next;}; 
		if ($_ =~ m/^File: /) {
			$info{"file"} = $_;
			chomp($info{'file'});
			$info{"file"} =~ s/File: //;
			chomp $info{"file"};
			if ($info{"file"} =~ m/^http:/){	# are we playing a local file
				$in = 1;			# or an internet stream?
				next;				#
			}					#
			my $tmp = -s $info{'file'};
			$info{"size"} = sprintf("%.2f MB", ((($tmp) / 1024) / 1024)) ;
			next;
		}
		
	}
	if (!($info{"state"} =~ m/PLAY/)) {return -1};		#check if moc is playing
	
	if ($in =~ 1){
		stream();
		return 0;
	}
	$info{"file"} =~ s/(.*\.)([a-zA-Z0-9]*)$/$2/;		#getting the  file extension
	$string = "moc is currently playing: $info{'artist'} - $info{'title'} on \"$info{'album'}\" | [$info{'current'}/$info{'total'}] " . 
			"| [$info{'bitrate'}] | [$info{'rate'}] | [$info{'size'}] | [$info{'file'}] " ;
	return 0;
	
}

sub stream {
	$string = "moc is currently playing: $info{'artist'} - $info{'title'} | [$info{'current'}] " . 
			"| [$info{'bitrate'}] | [$info{'rate'}] | [$info{'file'}] | [Streaming...] " ;
			$in = 0;
}

